'use strict';const kPaymentConfirmationScreen='../payment.html';var Payment={chromeEventId:null,trustedUILayers:{},init:function init(){window.addEventListener('mozChromeEvent',this);},handleEvent:function onMozChromeEvent(e){this.chromeEventId=e.detail.id;if(!this.chromeEventId)
return;var requestId=e.detail.requestId;switch(e.detail.type){case'open-payment-confirmation-dialog':var requests=e.detail.paymentRequests;if(!requests)
return;var returnSelection=(function returnSelection(selection){if(!selection)
return;this._dispatchEvent({id:this.chromeEventId,userSelection:selection});}).bind(this);if(requests.length==1){returnSelection(requests[0].type);return;}
var frame=document.createElement('iframe');frame.setAttribute('mozbrowser','true');frame.setAttribute('remote',true);frame.classList.add('screen');frame.src=kPaymentConfirmationScreen;frame.addEventListener('mozbrowserloadend',function addReqs(evt){var frame=evt.target;if(!frame||!requests)
return;var frameDocument=frame.contentWindow.document;var requestsList=frameDocument.getElementById('requests').getElementsByTagName('ul')[0];for(var i in requests){var requestElement=frameDocument.createElement('li');var button=frameDocument.createElement('button');button.setAttribute('value',requests[i].type);var requestText='Pay with '+requests[i].providerName+'\n'+
requests[i].productName+'\n'+
requests[i].productDescription+'\n'+
requests[i].productPrice[0].amount+' '+
requests[i].productPrice[0].currency;button.appendChild(frameDocument.createTextNode(requestText));button.onclick=function selectRequest(){returnSelection(this.getAttribute('value'));};requestElement.appendChild(button);requestsList.appendChild(requestElement);}});this._openTrustedUI(frame);break;case'open-payment-flow-dialog':this.trustedUILayers[requestId]=this.chromeEventId;var frame=document.createElement('iframe');frame.setAttribute('mozbrowser','true');frame.classList.add('screen');this._openTrustedUI(frame).then((function(){this._dispatchEvent({id:this.chromeEventId,frame:frame});}).bind(this));break;case'close-payment-flow-dialog':TrustedUIManager.close(this.trustedUILayers[requestId],(function dialogClosed(){this._dispatchEvent({id:this.chromeEventId});delete this.trustedUILayers[requestId];}).bind(this));break;}},_openTrustedUI:function _openTrustedUI(frame){var title=Service.currentApp.name;title=title?title:navigator.mozL10n.get('payment-flow');return TrustedUIManager.open(title,frame,this.chromeEventId);},_dispatchEvent:function _dispatchEvent(obj){var event=document.createEvent('CustomEvent');event.initCustomEvent('mozContentEvent',true,true,obj);window.dispatchEvent(event);}};if(navigator.mozL10n){navigator.mozL10n.once(Payment.init.bind(Payment));}